'From Squeak3.4beta of ''1 December 2002'' [latest update: #5138] on 5 January 2003 at 10:20:47 pm'!
"Change Set:		Time Zone patches
Date:			5 January 2003
Author:			David T. Lewis

Minor updates to enable convenient calculation of New Years Eve party times for any year, necessitated by the failure of y2k to bring about the much anticipated end of the world."!


!TimeZoneDatabase class methodsFor: 'examples' stamp: 'dtl 12/21/2002 11:16'!
partyTimes
	"Answer the times, in my own time zone, at which the New Year's Eve celebration
	for Year 2000 will occur for all time zones in the database. Sort the results so as to
	facilitate recognition of the grand events by committed revelers in my own time zone."

	"TimeZoneDatabase partyTimes"

	^ self partyTimesForNewYear: 2000
! !

!TimeZoneDatabase class methodsFor: 'examples' stamp: 'dtl 12/21/2002 11:15'!
partyTimesForNewYear: newYear
	"Answer the times, in my own time zone, at which the New Year's Eve celebration
	for the newYear will occur for all time zones in the database. Sort the results so as to
	facilitate recognition of the grand events by committed revelers in my own time zone."

	"TimeZoneDatabase partyTimesForNewYear: 2003"

	| db allZones myTimeZone c idx dateAndTime seconds result |
	db _ TimeZoneDatabase systemDatabase.
	db isNil ifTrue: [
		self notify: 'no system time zone database'.
		^ nil].
	allZones _ db allTimeZones.
	myTimeZone _ LocalTimeTransform here.
	c _ SortedCollection sortBlock: [:x :y | (x at: 3) <= (y at: 3)].
	idx _ 0.
	self showProgressFrom: 1 to: allZones size withMessage: 'checking times'
		forBlock: [ :bar |
			allZones do: [:e |
			idx _ idx + 1.
			bar value: idx.
			dateAndTime _ e transformDate: (self dateFromString: '01.01.', newYear asString)
						time: (Time fromSeconds: 0)
						toTimeZone: myTimeZone.
			seconds _ (dateAndTime at: 1) asSeconds + (dateAndTime at: 2) asSeconds.
			c add: (Array
				with: e
				with: (dateAndTime)
				with: seconds)]].
	result _ OrderedCollection new.
	c do: [:e | result add: (Array with: (e at: 1) timeZoneName with: (e at: 2))].
	^ result asArray

! !

